# Instalación de la extensión

## Instalar Requisitos previos

Para ejecutar la extensión se necesita tener instalados los siguientes programas:

- Python 3.x
- PostgreSQL Versión (TODO)
- Lenguaje PL/Python3u habilitado en PostgreSQL
- Make (para la instalación en linux)

### En Ubuntu / Linux Mint / Debian

```bash
sudo apt update && sudo apt install python3 postgresql postgresql-contrib make
```
### En Arch Linux / Manjaro

```bash
sudo pacman -Syu python postgresql make
# Inicializar y habilitar PostgreSQL
sudo su - postgres
initdb --locale $LANG -D /var/lib/postgres/data
exit
sudo systemctl enable postgresql
sudo systemctl start postgresql
```

### En Opensuse

```bash
sudo zypper refresh && sudo zypper install python3 postgresql postgresql-contrib make
```

### En Fedora
```bash
sudo dnf update && sudo dnf install python3 postgresql-server postgresql-contrib make
```

## Instalar la extensión en PostgreSQL
### En Linux
1\. Clone o descargue el repositorio:

```bash
git clone https://github.com/ZapExp/algoritmos_tree_plpython
```
2\. Navegue hasta la carpeta del proyecto:

```bash
cd ./algoritmos_tree_plpython
```
3\. Instale la extensión:

```bash
sudo make install
```

### En Windows:

TODO: pasos para windows

## Requisitos


## Crear la extensión en una base de datos

Una vez se ha instalado la extensión es posible añadirla a la base de datos, para crear la extensión ejecute el siguiente comando SQL mientras está conectado a la base de datos en la cual quiere instalar la extensión:

1. Conectese a su base de datos PostgreSQL

2. Ejecute el comando SQL:


```sql
CREATE EXTENSION algoritmos_arbol CASCADE;
```

Este comando creará el lenguaje PL/Python3u si aún no está presente y luego instalará la extensión.

## Verificar la instalación

Para verificar que la extensión se ha instalado correctamente, ejecute:

```sql
SELECT * FROM pg_extension WHERE extname = 'algoritmos_arbol';
```

Debería ver una fila con información sobre la extensión.
