# tabla = "tabla"
# esquema = "esquema"
# porcentaje_entrenamiento = 70
# esquema_entrenamiento = "esquema"
# tabla_entrenamiento = "tabla"
# esquema_pruebas = "esquema"
# tabla_pruebas = "tabla"
# sobreescribir = True

query = f"SELECT COUNT(*) FROM {esquema}.{tabla};"
total_filas = plpy.execute(query)[0]["count"]

cantidad_de_entrenamiento = int(total_filas * (porcentaje_entrenamiento / 100))
plpy.notice(f"cantidad de filas para de entrenamiento: {cantidad_de_entrenamiento}")

cantidad_pruebas = total_filas - cantidad_de_entrenamiento
plpy.notice(f"cantidad de filas para de pruebas: {cantidad_pruebas}")

if sobreescribir:
# Eliminar Tablas
    query = f"DROP TABLE IF EXISTS {esquema_pruebas}.{tabla_pruebas}"
    plpy.execute(query)

    query = f"DROP TABLE IF EXISTS {esquema_entrenamiento}.{tabla_entrenamiento}"
    plpy.execute(query)

# Crear la tabla de entrenamiento
query = f"""
CREATE TABLE {esquema_entrenamiento}.{tabla_entrenamiento} AS
SELECT * 
FROM {esquema}.{tabla}
"""
plpy.execute(query)


# Añadir id temporal
query = f"""
ALTER TABLE {esquema_entrenamiento}.{tabla_entrenamiento}
ADD COLUMN _id_temporal_pruebas INTEGER;
"""
plpy.execute(query)

# Darle valor al id temporal
query = f"""
WITH numbered_rows AS (
  SELECT *, ROW_NUMBER() OVER () AS row_num, ctid
  FROM {esquema_entrenamiento}.{tabla_entrenamiento}
)
UPDATE {esquema_entrenamiento}.{tabla_entrenamiento} AS e
SET _id_temporal_pruebas = nr.row_num
FROM numbered_rows nr
WHERE e.ctid = nr.ctid;
"""
plpy.execute(query)

# crear tabla de pruebas
query = f"""
CREATE TABLE {esquema_pruebas}.{tabla_pruebas} AS
SELECT * 
FROM {esquema_entrenamiento}.{tabla_entrenamiento}
ORDER BY RANDOM()
LIMIT {cantidad_pruebas};
"""
plpy.execute(query)

# Eliminar datos de la tabla de pruebas
# Que estén en la tabla de entrenamiento
query = f"""
DELETE FROM {esquema_entrenamiento}.{tabla_entrenamiento}
WHERE _id_temporal_pruebas IN (
    SELECT _id_temporal_pruebas
    FROM {esquema_pruebas}.{tabla_pruebas}
)
"""
plpy.execute(query)

# Eliminar columna de id temporal
query = f"""
ALTER TABLE {esquema_entrenamiento}.{tabla_entrenamiento}
DROP COLUMN _id_temporal_pruebas
"""
plpy.execute(query)

query = f"""
ALTER TABLE {esquema_pruebas}.{tabla_pruebas}
DROP COLUMN _id_temporal_pruebas
"""
plpy.execute(query)


# Eliminar Tablas

plpy.notice(f"Se creó la tabla {esquema_entrenamiento}.{tabla_entrenamiento}")
plpy.notice(f"Se creó la tabla {esquema_pruebas}.{tabla_pruebas}")
