def construir_arbol_desde_tabla():
    def obtener_hijos(id_padre):
        query = f"""
        SELECT * FROM algoritmos_arbol.nodos 
        WHERE id_padre = {id_padre} 
        """
        return plpy.execute(query)

    def construir_nodo(nodo, es_ultimo=False, prefijo=""):
        arbol_str = ""

        if nodo["id_padre"] == -1:
            query = "SELECT valor from algoritmos_arbol.info WHERE id = 'tabla'"
            tabla = plpy.execute(query)[0]["valor"]
            arbol_str += f"· └─ {tabla}"
            query = "SELECT count(*) as cuenta from algoritmos_arbol.nodos"
            cuenta = plpy.execute(query)[0]["cuenta"]
            if cuenta == 1:
                total = int(
                    nodo["instancias_cantidad_correctas"]
                    + nodo["instancias_cantidad_incorrectas"]
                )
                arbol_str += f" -> {nodo['clase']} - ({total} / {nodo['instancias_cantidad_incorrectas']}) - {int(nodo['instancias_cantidad_correctas'])*100/total:.2f}%\n"
            nuevo_prefijo = "·    "
        else:
            if es_ultimo:
                arbol_str += f"{prefijo}└─ "
                nuevo_prefijo = prefijo + "   "
            else:
                arbol_str += f"{prefijo}├─ "
                nuevo_prefijo = prefijo + "│  "

            arbol_str += (
                f"{nodo['atributo']} {nodo['comparador']} {nodo['atributo_valor']}"
            )

        if nodo["tipo"] == "HOJA":
            if nodo["instancias_cantidad_incorrectas"] == 0:
                arbol_str += (
                    f" -> {nodo['clase']} - ({nodo['instancias_cantidad_correctas']}) - 100.00%\n"
                )
            else:
                total = int(
                    nodo["instancias_cantidad_correctas"]
                    + nodo["instancias_cantidad_incorrectas"]
                )
                arbol_str += f" -> {nodo['clase']} - ({total} / {nodo['instancias_cantidad_incorrectas']}) - {int(nodo['instancias_cantidad_correctas'])*100/total:.2f}%\n"
        else:
            arbol_str += "\n"
            hijos = obtener_hijos(nodo["id"])
            for i, hijo in enumerate(hijos):
                arbol_str += construir_nodo(hijo, i == len(hijos) - 1, nuevo_prefijo)

        return arbol_str

    raiz = plpy.execute("SELECT * FROM algoritmos_arbol.nodos WHERE id_padre = -1")[0]

    return construir_nodo(raiz)



arbol_str = "==== Arbol ====\n"
arbol_str += construir_arbol_desde_tabla()

hojas = plpy.execute("SELECT valor FROM algoritmos_arbol.info WHERE id = 'num_hojas'")[0]["valor"]
nodos = plpy.execute("SELECT valor FROM algoritmos_arbol.info WHERE id = 'num_nodos'")[0]["valor"]

arbol_str += "\n"
#arbol_str += f"\nNúmero de hojas: {hojas}\n"
#arbol_str += f"\nTamaño del arbol: {nodos}\n"

 
plpy.execute("delete from algoritmos_arbol.textos_evaluacion where id='arbol'")
plpy.execute("insert into algoritmos_arbol.textos_evaluacion(id, valor) values ('arbol', '{}')".format(arbol_str.replace("'", "''")))


plpy.notice(arbol_str)
