query = """
    SELECT length(titulo) as longitud
    FROM algoritmos_arbol.info_evaluacion
    ORDER BY length(titulo) DESC
    LIMIT 1;
"""
espacio_izquierdo = plpy.execute(query)[0]["longitud"]
espacio_izquierdo += 2

texto_a_mostrar = "==== Información de la Evaluación ====\n"

query = """
    SELECT titulo, valor
    FROM algoritmos_arbol.info_evaluacion
    WHERE id = 'inst_total'
"""
resultado = plpy.execute(query)[0]
total = int(resultado["valor"])
texto_a_mostrar += f"{resultado["titulo"]:<{espacio_izquierdo}} {total}\n"

query = """
    SELECT id, titulo, valor
    FROM algoritmos_arbol.info_evaluacion
    WHERE id = 'inst_correctas'
"""
resultado = plpy.execute(query)[0]
cantidad_correctas = int(resultado["valor"])
porcentaje = 100 * cantidad_correctas / total
texto_a_mostrar += f"{resultado["titulo"]:<{espacio_izquierdo}} {cantidad_correctas}   {porcentaje:.2f}%\n"

query = """
    SELECT id, titulo, valor
    FROM algoritmos_arbol.info_evaluacion
    WHERE id = 'inst_incorrectas'
"""
resultado = plpy.execute(query)[0]
cantidad_incorrectas = int(resultado["valor"])
porcentaje = 100 * cantidad_incorrectas / total
texto_a_mostrar += f"{resultado["titulo"]:<{espacio_izquierdo}} {cantidad_incorrectas}   {porcentaje:.2f}%\n"

query = """
    SELECT id, titulo, valor
    FROM algoritmos_arbol.info_evaluacion
    WHERE id = 'kappa'
"""
resultado = plpy.execute(query)[0]
valor = resultado["valor"]
texto_a_mostrar += f"{resultado["titulo"]:<{espacio_izquierdo}} {valor:.4f}\n"

query = """
    SELECT id, titulo, valor
    FROM algoritmos_arbol.info_evaluacion
    WHERE id = 'err_abs_medio'
"""
resultado = plpy.execute(query)[0]
valor = resultado["valor"]
texto_a_mostrar += f"{resultado["titulo"]:<{espacio_izquierdo}} {valor:.4f}\n"

query = """
    SELECT id, titulo, valor
    FROM algoritmos_arbol.info_evaluacion
    WHERE id = 'raiz_err_abs_cuad'
"""
resultado = plpy.execute(query)[0]
valor = resultado["valor"]
texto_a_mostrar += f"{resultado["titulo"]:<{espacio_izquierdo}} {valor:.4f}\n"

query = """
    SELECT id, titulo, valor
    FROM algoritmos_arbol.info_evaluacion
    WHERE id = 'err_abs_rel'
"""
resultado = plpy.execute(query)[0]
valor = resultado["valor"]
texto_a_mostrar += f"{resultado["titulo"]:<{espacio_izquierdo}} {valor:.2f}%\n"

query = """
    SELECT id, titulo, valor
    FROM algoritmos_arbol.info_evaluacion
    WHERE id = 'raiz_err_cuad_rel'
"""
resultado = plpy.execute(query)[0]
valor = resultado["valor"]
texto_a_mostrar += f"{resultado["titulo"]:<{espacio_izquierdo}} {valor:.2f}%\n\n"


plpy.execute("delete from algoritmos_arbol.textos_evaluacion where id='info_evaluacion'")
plpy.execute("insert into algoritmos_arbol.textos_evaluacion(id, valor) values ('info_evaluacion', '{}')".format(texto_a_mostrar.replace("'", "''")))

plpy.notice(texto_a_mostrar)
