-- hacer que solo se pueda ejecutar como extensión
\echo Utiliza "CREATE EXTENSION algoritmos_arbol CASCADE" para cargar este archivo. \quit

-- Crear schema para guardar las tablas de entrenamiento
CREATE SCHEMA algoritmos_arbol_datos;

CREATE TABLE nodos
(
  id                              INTEGER, -- Id del Nodo (-1 si es la raiz)
  id_padre                        INTEGER, -- Id del nodo padre
  tipo                            VARCHAR, -- tipo de nodo: RAIZ, RAMA, HOJA
  atributo                        VARCHAR, -- atributo de la rama (-1 si es la raiz)
  comparador                      VARCHAR, -- comparador (=)
  atributo_valor                  VARCHAR, -- valor del atributo de la rama (-1 si es la raiz)
  clase                           VARCHAR, -- clase elegida (-1 si no es una HOJA)
  instancias_cantidad_correctas   INTEGER, -- cantidad de instancias clasificadas correctamente
  instancias_cantidad_incorrectas INTEGER  -- cantidad de instancias clasificadas correctamente
);

CREATE TABLE IF NOT EXISTS info
(
  id     VARCHAR,
  titulo VARCHAR,
  valor  VARCHAR
);

CREATE TABLE IF NOT EXISTS textos_evaluacion
(
  id     VARCHAR,
  valor  TEXT
);


CREATE TABLE IF NOT EXISTS estadisticas_evaluacion
(
  tipo       VARCHAR, -- PARCIAL, TOTAL
  clase      VARCHAR,
  tpr        REAL,
  fpr        REAL,
  presicion  REAL,
  recall     REAL,
  f_measure  REAL,
  mcc        REAL,
  roc_area   REAL,
  prc_area   REAL
);

CREATE TABLE IF NOT EXISTS info_evaluacion
(
  id     VARCHAR,
  titulo VARCHAR,
  valor  REAL
);

CREATE TABLE matriz_confusion
(
  fila     VARCHAR,
  columna  VARCHAR,
  cantidad INTEGER
);

CREATE TABLE clases_probabilidades(
  nodo         INTEGER,
  clase        VARCHAR,
  probabilidad REAL
);

CREATE TABLE cantidades_anteriores(
  clase    VARCHAR,
  cantidad INTEGER
);

CREATE TABLE clasificados(
  id       SERIAL PRIMARY KEY,
  clase    VARCHAR,
  cantidad INTEGER
);

CREATE TABLE clasificados_probabilidades(
  id           INTEGER,
  clase        VARCHAR,
  probabilidad REAL,
  FOREIGN KEY (id) REFERENCES clasificados(id) ON DELETE CASCADE
);
