let
  pkgs = import <nixpkgs> { };
in
pkgs.mkShell {
  RUST_SRC_PATH = "${pkgs.rust.packages.stable.rustPlatform.rustLibSrc}";

  nativeBuildInputs = with pkgs; [
    # for tauri
    rustc
    cargo
    cargo-tauri
    nodejs
    pkg-config
    gobject-introspection

    # for development
    svelte-language-server
    rust-analyzer
    tailwindcss-language-server
  ];

  buildInputs = with pkgs; [
    at-spi2-atk
    atkmm
    cairo
    gdk-pixbuf
    glib
    gtk3
    harfbuzz
    librsvg
    libsoup_3
    pango
    webkitgtk_4_1
    openssl
  ];
}
